#!/www/python/bin/python

# Test Optik help generation.  Not automated -- you have to read the
# output and see if it makes sense/looks good!

__revision__ = "$Id: test_help.py,v 1.5 2002/08/09 21:33:13 gward Exp $"

from optik import make_option, OptionGroup, OptionParser, SUPPRESS_HELP

hbar = "-"*72

options = [
    make_option("-a", type="string", dest='a',
                metavar="APPLE", help="throw APPLEs at basket"),
    make_option("-b", "--boo", type="int", dest='boo',
                metavar="NUM",
                help="shout \"boo!\" NUM times (in order to frighten away "
                "all the evil spirits that cause trouble and mayhem)"),
    make_option("--foo", action="append", type="string", dest='foo',
                help="store FOO in the foo list for later fooing"),
    ]
usage = "usage: %prog [options]"
parser = OptionParser(usage=usage, option_list=options)
parser.print_help()

print hbar

parser.set_description("This is the program description.  This program has "
                       "an option group as well as single options.")
group = OptionGroup(parser, "Dangerous Options",
                    "Caution: use of these options is at your own risk.")
group.add_option("-g", action="store_true", help="Group option.")
parser.add_option_group(group)
parser.print_help()

print hbar

usage = "usage: %prog [options] arg1 arg2"
parser = OptionParser(usage)
parser.add_option("-v", "--verbose",
                  action="store_true", dest="verbose", default=1,
                  help="make lots of noise [default]")
parser.add_option("-q", "--quiet",
                  action="store_false", dest="verbose", 
                  help="be vewwy quiet (I'm hunting wabbits)")
parser.add_option("-f", "--file",
                  action="store", type="string", dest="filename",
                  metavar="FILE", help="write output to FILE"),
parser.add_option("-m", "--mode",
                  action="store", type="string", dest="mode",
                  default="intermediate",
                  help="interaction mode: one of 'novice', "
                       "'intermediate' [default], 'expert'")
parser.print_help()
